var app = getApp();
var $gbk = require('../../utils/gbk');
var Buffer = require('buffer/').Buffer;
var toArrayBuffer = require('to-array-buffer');
Page({
	data: {
		currentDevName: 'defaulName',
		currentConnectionState: '已连接',

		recvTotalBytes: '0',
		recvCrc32: '0',

		sendTotalBytesCounter: 0,
		sendTotalBytes: '0',
		sendCrc32: '0',

		recv_data: '',
		scrollTop: 100,
		send_data: '',

		devId: '123',
		services: [
			'22',
		],
		connected: false,

		notifyServiceId: 'invalid',
		notifyCharacteristicId: 'invalid',
		notifyServiceSearchIndex: 0,

		writeServiceId: 'invalid',
		writeCharacteristicId: 'invalid',
		writeServiceSearchIndex: 0,
		uiImageEndData: []

	},

	seekFirstNotifyCharacteristic: function () {
		var that = this;
		if (that.data.notifyServiceSearchIndex < that.data.services.length && that.data.notifyCharacteristicId == 'invalid') {
			that.data.notifyServiceId = that.data.services[that.data.notifyServiceSearchIndex].uuid
			console.log('Search service index ', that.data.notifyServiceSearchIndex, 'service: ', that.data.notifyServiceId)
				++that.data.notifyServiceSearchIndex;
			wx.getBLEDeviceCharacteristics({
				// 这里的 devId 需要在 getBluetoothDevices 或 onBluetoothDeviceFound 接口中获取
				deviceId: that.data.devId,
				// 这里的 notifyServiceId 需要在 getBLEDeviceServices 接口中获取
				serviceId: that.data.notifyServiceId,
				complete: function () {
					console.log('device getBLEDeviceCharacteristics complete', that.data.notifyServiceSearchIndex)
					//递归调用自身直到找到notify特征或遍历完所有特征
					that.seekFirstNotifyCharacteristic()
				},
				success: function (res) {
					console.log('device getBLEDeviceCharacteristics:', res.characteristics)
					for (var n = 0; n < res.characteristics.length && that.data.notifyCharacteristicId == 'invalid'; ++n) {
						if (res.characteristics[n].properties.notify == true) {
							console.log('device notify Characteristics found', n)
							that.data.notifyCharacteristicId = res.characteristics[n].uuid
							console.log('notify servcie:', that.data.notifyServiceId)
							console.log('notify characteristic:', that.data.notifyCharacteristicId)
							console.log('start notify')
							wx.notifyBLECharacteristicValueChanged({
								state: true, // 启用 notify 功能
								// 这里的 devId 需要在 getBluetoothDevices 或 onBluetoothDeviceFound 接口中获取
								deviceId: that.data.devId,
								// 这里的 notifyServiceId 需要在 getBLEDeviceServices 接口中获取
								serviceId: that.data.notifyServiceId,
								// 这里的 notifyCharacteristicId 需要在 getBLEDeviceCharacteristics 接口中获取
								characteristicId: that.data.notifyCharacteristicId,
								success: function (res) {
									console.log('notifyBLECharacteristicValueChanged success', res.errMsg)
									wx.showToast({
										title: '连接成功',
										icon: 'success',
										duration: 2000
									})
									that.setData({
										currentConnectionState: '已连接'
									});

									// 寻找第一个write特征
									that.data.writeServiceSearchIndex = 0
									that.data.writeCharacteristicId = 'invalid'
									that.seekFirstWriteCharacteristic()

									//加载本地图片
									that.loadImageFromLocal()
								}
							})
						}
					}
				}
			})
		}
	},

	seekFirstWriteCharacteristic: function () {
		var that = this;

		if (that.data.writeServiceSearchIndex < that.data.services.length && that.data.writeCharacteristicId == 'invalid') {
			that.data.writeServiceId = that.data.services[that.data.writeServiceSearchIndex].uuid
			console.log('Search service index ', that.data.writeServiceSearchIndex, 'service: ', that.data.writeServiceId)
				++that.data.writeServiceSearchIndex;
			wx.getBLEDeviceCharacteristics({
				// 这里的 devId 需要在 getBluetoothDevices 或 onBluetoothDeviceFound 接口中获取
				deviceId: that.data.devId,
				// 这里的 writeServiceId 需要在 getBLEDeviceServices 接口中获取
				serviceId: that.data.writeServiceId,
				complete: function () {
					console.log('device getBLEDeviceCharacteristics complete', that.data.writeServiceSearchIndex)
					//递归调用自身直到找到write特征或遍历完所有特征
					that.seekFirstWriteCharacteristic()
				},
				success: function (res) {
					console.log('device getBLEDeviceCharacteristics:', res.characteristics)

					for (var n = 0; n < res.characteristics.length && that.data.writeCharacteristicId == 'invalid'; ++n) {
						if (res.characteristics[n].properties.write == true) {
							console.log('device write Characteristics found', n)
							that.data.writeCharacteristicId = res.characteristics[n].uuid
							console.log('write servcie:', that.data.writeServiceId)
							console.log('write characteristic:', that.data.writeCharacteristicId)
						}
					}
				}
			})
		}
	},

	onLoad: function (options) {
		var btDevId = options.devId;
		var that = this;

		var num = that.data.services.length
		that.data.services.splice(0, num)
		that.setData({
			services: that.data.services
		});
		for (var i = 0; i < app.globalData.btDevices.length; ++i) {
			if (app.globalData.btDevices[i].devId == btDevId) {
				console.log('!!!createBLEConnection', btDevId)
				that.setData({
					currentDevName: app.globalData.btDevices[i].name,
					currentConnectionState: '连接中...',
				});
				wx.createBLEConnection({
					// 这里的 btDevId 需要在上面的 getBluetoothDevices 或 onBluetoothDeviceFound 接口中获取
					deviceId: app.globalData.btDevices[i].devId,
					success: function (res) {
						that.data.devId = btDevId;
						// if (app.globalData.platform == 'ios' && app.globalData.environment) {
						// 	setTimeout(function () {
						// 		that.getBLEDeviceServices();
						// 	}, 1000);
						// } else {
						// 	that.getBLEDeviceServices();
						// }
						setTimeout(function () {
							that.getBLEDeviceServices();
						}, 1000);
					}
				});
				break;
			}
		}

	},

	getBLEDeviceServices: function () {
		var that = this;
		wx.getBLEDeviceServices({
			// 这里的 devId 需要在 getBluetoothDevices 或 onBluetoothDeviceFound 接口中获取
			deviceId: that.data.devId,
			success: function (res) {
				console.log('device services:', res.services)
				// 保存已连接设备的服务
				for (var j = 0; j < res.services.length; ++j) {
					var newService = [
						res.services[j],
					]
					that.data.services = that.data.services.concat(newService)
					console.log(j, that.data.services.length, res.services.length)
				}
				that.setData({
					services: that.data.services
				});

				// 寻找第一个Notify特征
				that.data.notifyServiceSearchIndex = 0
				that.data.notifyCharacteristicId = 'invalid'
				that.seekFirstNotifyCharacteristic()
			},
			fail: function () {
				console.log('device services:', 'getBLEDeviceServices接口调用失败')
			}
		})
	},

	onShow: function () {
		var that = this;
		wx.onBLECharacteristicValueChange(function (res) {
			var lang = that.data.recv_data;
			console.log(`characteristic ${res.characteristicId} has changed, now is ${res.value}`)
			console.log(String.fromCharCode.apply(null, new Uint8Array(res.value)))
			lang += String.fromCharCode.apply(null, new Uint8Array(res.value))
			that.setData({
				recvTotalBytes: lang.length.toString(),
				recv_data: lang,
				scrollTop: that.data.scrollTop + 20
			});
		})

		wx.onBLEConnectionStateChanged(function (res) {
			console.log(`device ${res.deviceId} state has changed, connected: ${res.connected}`)
		})

		wx.onBluetoothAdapterStateChange(function (res) {
			console.log(`adapterState changed, now is`, res)
		})
	},

	sleep: function (n) {
		var start = new Date().getTime();
		while (true) {
			if (new Date().getTime() - start > n) {
				break;
			}
		}
	},

	onUnload: function () {
		var that = this;
		wx.closeBLEConnection({
			deviceId: that.data.devId,
			success: function (res) {
				console.log(res)
			}
		})
	},
	toGBKBytes: function (str) {
		var str = $gbk.encode(str)
		var byteArr = new Array();
		for (var i = 0; i < str.length; i++) {
			var ch = str.charAt(i);
			if (ch == '%') {
				var num = str.charAt(i + 1) + str.charAt(i + 2);
				num = parseInt(num, 16);
				num = num | (-1 << 8);
				byteArr.push(num);
				i += 2;
			} else {
				byteArr.push(ch.charCodeAt());
			}
		}
		return byteArr;
	},
	toUTF8Bytes: function (str) {
		var bytes = new Array();
		var len, c;
		len = str.length;
		for (var i = 0; i < len; i++) {
			c = str.charCodeAt(i);
			if (c >= 0x010000 && c <= 0x10FFFF) {
				bytes.push(((c >> 18) & 0x07) | 0xF0);
				bytes.push(((c >> 12) & 0x3F) | 0x80);
				bytes.push(((c >> 6) & 0x3F) | 0x80);
				bytes.push((c & 0x3F) | 0x80);
			} else if (c >= 0x000800 && c <= 0x00FFFF) {
				bytes.push(((c >> 12) & 0x0F) | 0xE0);
				bytes.push(((c >> 6) & 0x3F) | 0x80);
				bytes.push((c & 0x3F) | 0x80);
			} else if (c >= 0x000080 && c <= 0x0007FF) {
				bytes.push(((c >> 6) & 0x1F) | 0xC0);
				bytes.push((c & 0x3F) | 0x80);
			} else {
				bytes.push(c & 0xFF);
			}
		}
		return bytes;


	},
	//以图片的形式打印
	bingButtonSendImage: function () {
		var that = this;
		var allData = []
		//SIZE指令：SIZE m mm,n mm  打印标签的大小，200DPI打印机: 1 mm = 8 dots，300DPI打印机: 1mm = 12 dots，我们的打印机是200DPI，所以1mm对应8个像素点
		//CLS指令：清除画板的缓存。
		allData = allData.concat(that.toGBKBytes("SIZE 40mm,50mm\r\nDIRECTION 1\r\nCLS\r\n"))
		//BITMAP指令：BITMAP X,Y,width,height,mode,bitmap data…，需要注意的是宽和高的单位，宽传的是：mm（比如320px的宽，200dpi的打印机的话，1 mm= 8dots，那么传40.0），高传的是：dots，即像素，也就是px
		allData = allData.concat(that.toGBKBytes("BITMAP 0,0,40,400,1,"))
		allData = allData.concat(that.data.uiImageEndData[0])
		allData = allData.concat(that.toGBKBytes("\r\n"))
		//打印的张数，如果需要打印多张的话，第二个1更改为要打印的张数
		allData = allData.concat(that.toGBKBytes("PRINT 1,1\r\n"))
		if (app.globalData.platform == "ios") {
			that.printfTSPL(allData, 1000)
		} else if (app.globalData.platform == "android") {
			that.printfTSPL(allData, 20)
		}
	},
	//打印案例1
	//宽72mm，高85mm，请注意，我们打印机是200dpi，则1mm = 8px，请注意绘制的内容是x坐标和y坐标，是否超出了宽高
	//DIRECTION 1：出纸方向的指令
	bingButtonSendExample: function () {
		let that = this;
		let allData = []
		allData = allData.concat(that.toGBKBytes("SIZE 72mm,85mm\r\nDIRECTION 1\r\nCLS\r\n"))
		allData = allData.concat(that.toGBKBytes("BAR 0,8,568,4\r\n"))
		allData = allData.concat(that.toGBKBytes("QRCODE 216,25,H,7,M,0,M1,S1,\"测试的二维码的内容\"\r\n"))
		allData = allData.concat(that.toGBKBytes("BAR 0,230,568,4\r\n"))
		allData = allData.concat(that.toGBKBytes("TEXT 10,245,\"0\",0,1.2,1.2,\"北京精巨科技有限公司\"\r\n"))
		allData = allData.concat(that.toGBKBytes("BAR 0,290,568,4\r\n"))
		allData = allData.concat(that.toGBKBytes("TEXT 10,305,\"0\",0,1.2,1.2,\"资产名称：电脑主机\"\r\n"))
		allData = allData.concat(that.toGBKBytes("BAR 0,350,568,4\r\n"))
		allData = allData.concat(that.toGBKBytes("TEXT 10,365,\"0\",0,1.2,1.2,\"部门名称：联想\"\r\n"))
		allData = allData.concat(that.toGBKBytes("BAR 0,410,568,4\r\n"))
		allData = allData.concat(that.toGBKBytes("TEXT 10,425,\"0\",0,1.2,1.2,\"规格型号：华为6a\"\r\n"))
		allData = allData.concat(that.toGBKBytes("BAR 0,470,568,4\r\n"))
		allData = allData.concat(that.toGBKBytes("TEXT 10,485,\"0\",0,1.2,1.2,\"资产编码：JC41525175\"\r\n"))
		allData = allData.concat(that.toGBKBytes("BAR 0,530,568,4\r\n"))
		allData = allData.concat(that.toGBKBytes("TEXT 10,545,\"0\",0,1.2,1.2,\"购买日期：2018-10-18\"\r\n"))
		allData = allData.concat(that.toGBKBytes("BAR 0,590,568,4\r\n"))
		allData = allData.concat(that.toGBKBytes("TEXT 10,605,\"0\",0,1.2,1.2,\"使用人员：丁永宏\"\r\n"))
		allData = allData.concat(that.toGBKBytes("BAR 0,658,568,4\r\n"))
		allData = allData.concat(that.toGBKBytes("BAR 0,8,4,650\r\n"))
		allData = allData.concat(that.toGBKBytes("BAR 568,8,4,650\r\n"))
		allData = allData.concat(that.toGBKBytes("PRINT 1,1\r\n"))
		that.printfTSPL(allData, 20)
	},
	//打印案例2
	bingButtonSendExample2: function () {
		let that = this;
		let allData = []
		allData = allData.concat(that.toGBKBytes("SIZE 70mm,50mm\r\nDIRECTION 0\r\nCLS\r\n"))
		allData = allData.concat(that.toGBKBytes("TEXT 10,76,\"0\",0,1.2,1.2,\"北京精巨科技有限公司\"\r\n"))
		allData = allData.concat(that.toGBKBytes("TEXT 10,140,\"0\",0,1.2,1.2,\"资产名称：柜子\"\r\n"))
		allData = allData.concat(that.toGBKBytes("QRCODE 408,64,H,3,M,0,M1,S1,\"测试的二维码的内容\"\r\n"))
		allData = allData.concat(that.toGBKBytes("TEXT 10,204,\"0\",0,1.2,1.2,\"资产编号：JP83908848\"\r\n"))
		allData = allData.concat(that.toGBKBytes("TEXT 10,268,\"0\",0,1.2,1.2,\"部门名称：客服部\"\r\n"))
		allData = allData.concat(that.toGBKBytes("TEXT 10,332,\"0\",0,1.2,1.2,\"使用人员：张红帅\"\r\n"))
		allData = allData.concat(that.toGBKBytes("PRINT 1,1\r\n"))
		that.printfTSPL(allData, 20)
	},
	//打印案例3
	//注意TEXT指令的x，y（调大小）范围是1~10，小于1的兼容性不好，不要使用，即字体最小设置为1，1.
	bingButtonSendExample3: function () {
		let that = this;
		let allData = []
		allData = allData.concat(that.toGBKBytes("SIZE 60mm,30mm\r\nDIRECTION 1\r\nCLS\r\n"))
		allData = allData.concat(that.toGBKBytes("BAR 0,8,472,4\r\n"))
		allData = allData.concat(that.toGBKBytes("TEXT 10,18,\"0\",0,1,1,\"素材20859-Coat\"\r\n"))
		allData = allData.concat(that.toGBKBytes("BAR 0,44,314,4\r\n"))
		allData = allData.concat(that.toGBKBytes("TEXT 10,54,\"0\",0,1,1,\"编码\"\r\n"))
		allData = allData.concat(that.toGBKBytes("TEXT 144,54,\"0\",0,1,1,\"1.0101.000024\"\r\n"))
		allData = allData.concat(that.toGBKBytes("BAR 0,80,314,4\r\n"))
		allData = allData.concat(that.toGBKBytes("TEXT 10,90,\"0\",0,1,1,\"规格\"\r\n"))
		allData = allData.concat(that.toGBKBytes("TEXT 144,90,\"0\",0,1,1,\"12.7*公斤/公斤\"\r\n"))
		allData = allData.concat(that.toGBKBytes("BAR 0,116,314,4\r\n"))
		allData = allData.concat(that.toGBKBytes("TEXT 10,126,\"0\",0,1,1,\"仓库\"\r\n"))
		allData = allData.concat(that.toGBKBytes("TEXT 96,126,\"0\",0,1,1,\"原材料仓\"\r\n"))
		allData = allData.concat(that.toGBKBytes("TEXT 344,126,\"0\",0,1,1,\"CL1912132\"\r\n"))
		allData = allData.concat(that.toGBKBytes("QRCODE 344,18,H,3,A,0,M1,S1,\"测试的二维码的内容\"\r\n"))
		allData = allData.concat(that.toGBKBytes("BAR 0,152,472,4\r\n"))
		allData = allData.concat(that.toGBKBytes("TEXT 10,162,\"0\",0,1,1,\"供应商\"\r\n"))
		allData = allData.concat(that.toGBKBytes("TEXT 96,162,\"0\",0,1,1,\"鑫科\"\r\n"))
		allData = allData.concat(that.toGBKBytes("TEXT 238,162,\"0\",0,1,1,\"日期\"\r\n"))
		allData = allData.concat(that.toGBKBytes("TEXT 344,162,\"0\",0,1,1,\"2019-12-18\"\r\n"))
		allData = allData.concat(that.toGBKBytes("BAR 0,188,472,4\r\n"))
		allData = allData.concat(that.toGBKBytes("TEXT 10,198,\"0\",0,1,1,\"批次\"\r\n"))
		allData = allData.concat(that.toGBKBytes("TEXT 80,198,\"0\",0,1,1,\"2019-12-18\"\r\n"))
		allData = allData.concat(that.toGBKBytes("TEXT 238,198,\"0\",0,1,1,\"备注\"\r\n"))
		allData = allData.concat(that.toGBKBytes("BAR 0,224,472,4\r\n"))
		allData = allData.concat(that.toGBKBytes("BAR 0,8,4,220\r\n"))
		allData = allData.concat(that.toGBKBytes("BAR 224,116,4,108\r\n"))
		allData = allData.concat(that.toGBKBytes("BAR 314,8,4,220\r\n"))
		allData = allData.concat(that.toGBKBytes("BAR 472,8,4,220\r\n"))
		allData = allData.concat(that.toGBKBytes("PRINT 1\r\n"))
		that.printfTSPL(allData, 20)
	},
	//打印直线
	//BAR指令：BAR x,y,width,height
	bingButtonSendStraight: function () {
		let that = this;
		let allData = []
		allData = allData.concat(that.toGBKBytes("SIZE 70mm,10mm\r\nDIRECTION 1\r\nCLS\r\n"))
		allData = allData.concat(that.toGBKBytes("BAR 0,0,576,4\r\n"))
		allData = allData.concat(that.toGBKBytes("PRINT 1,1\r\n"))
		that.printfTSPL(allData, 20)
	},

	//打印文字GBK编码
	bingButtonSendTextGBK: function () {
		let that = this;
		let allData = []
		//SIZE指令：SIZE m mm,n mm  打印标签的大小，200DPI打印机: 1 mm = 8 dots，即1mm对应8个像素点
		//CLS指令：清除画板的缓存。
		allData = allData.concat(that.toGBKBytes("SIZE 70mm,20mm\r\nDIRECTION 1\r\nCLS\r\n"))
		allData = allData.concat(that.toGBKBytes("TEXT 0,0,\"0\",0,1.2,1.2,\"微信小程序打印标签，文字测试文字，GBK\"\r\n"))
		allData = allData.concat(that.toGBKBytes("TEXT 0,50,\"0\",0,1.2,1.2,\"微信小程序打印标签，文字测试文字，GBK\"\r\n"))
		//打印的张数，如果需要打印多张的话，第二个1更改为要打印的张数
		allData = allData.concat(that.toGBKBytes("PRINT 1,1\r\n"))
		//打印
		that.printfTSPL(allData, 20)
	},
	//打印二维码
	//QRCODE指令：QRCODE x,y,ECC Level,cell width,mode,rotation,[model,mask,]"content"
	bingButtonSendQR: function () {
		let that = this;
		let allData = []
		allData = allData.concat(that.toGBKBytes("SIZE 70mm,30mm\r\nDIRECTION 1\r\nCLS\r\n"))
		allData = allData.concat(that.toGBKBytes("QRCODE 0,10,H,1,M,0,M1,S1,\"测试的二维码的内容1\"\r\n"))
		allData = allData.concat(that.toGBKBytes("QRCODE 200,10,H,7,M,0,M1,S1,\"测试的二维码的内容2\"\r\n"))
		allData = allData.concat(that.toGBKBytes("PRINT 1,1\r\n"))
		that.printfTSPL(allData, 20)
	},

	//打印方法
	printfTSPL: function (printfData, subpackage) {
		let that = this;
		var subpackageSize = Math.ceil(printfData.length / subpackage)

		function split_array(arr, len) {
			var a_len = arr.length;
			var result = []
			for (var i = 0; i < a_len; i += len) {
				result.push(arr.slice(i, i + len))
			}
			return result;
		}
		//因为目前微信只是实现了低功耗蓝牙的连接，所以需要分包发，微信小程序官方建议是 每次发20byte
		let sendloop = split_array(printfData, subpackage)
		console.log('拆分的结果:', sendloop)
		wx.showLoading({
			title: '打印中',
			mask: true
		})

		function realWriteData(sendloop, i) {
			if (i >= sendloop.length) {
				return
			}
			console.log('i:', i)
			let newsenddata = sendloop[i]
			let buffer = toArrayBuffer(Buffer.from(newsenddata));
			wx.writeBLECharacteristicValue({
				deviceId: that.data.devId,
				serviceId: that.data.writeServiceId,
				characteristicId: that.data.writeCharacteristicId,
				// 这里的value是ArrayBuffer类型
				value: buffer,
				success: function (res) {
					realWriteData(sendloop, i + 1);
					if (i === subpackageSize - 1) {
						wx.showToast({
							title: '打印成功',
							icon: 'success',
							duration: 2000
						})
					}
				}
			})
		}
		console.log(sendloop.length);
		let i = 0;
		realWriteData(sendloop, 0);
	},
	//图片二值化
	convertToBMW(res) {
		let arr = []
		let data = []
		//RGBA
		for (let i = 0; i < res.length; i += 4) {
			//灰度转换RGB比例取值
			let gray = 0.29900 * res[i] + 0.58700 * res[i + 1] + 0.11400 * res[i + 2];
			//阈值：128
			if (gray <= 128) {
				res[i] = 0;
			} else {
				res[i] = 1;
			}
			arr.push(res[i]);
		}
		for (let k = 0; k < arr.length; k += 8) {
			let temp = arr[k] * 128 + arr[k + 1] * 64 + arr[k + 2] * 32 + arr[k + 3] * 16 + arr[k + 4] * 8 + arr[k + 5] * 4 + arr[k + 6] * 2 + arr[k + 7] * 1
			data.push(temp);
		}
		return data;
	},
	//加载图片
	loadImageFromLocal() {
		wx.showLoading({
			title: '加载图片中',
			mask: true
		})
		let that = this;
		var canvas = wx.createCanvasContext('shareCanvas')
		canvas.drawImage('/imgs/tupian.png', 0, 0, 320, 400);
		canvas.draw(true, setTimeout(function () {
			wx.canvasToTempFilePath({
				canvasId: 'shareCanvas',
				success: function (res) {
					wx.canvasGetImageData({
						canvasId: 'shareCanvas',
						x: 0,
						y: 0,
						width: 320,
						height: 400,
						success(res) {
							let data = that.convertToBMW(res.data);
							//console.log("图片二值化后的数据:", data);
							that.data.uiImageEndData.push(data)
						},
						fail: function (error) {
							console.log("error:" + error);
						},
						complete: function () {
							wx.hideLoading()
						}
					})
				},
			})
		}, 1000));

		// wx.getImageInfo({
		// 	src: 'https://www.mhtclouding.com/MHT/MHTFile1/tempImage/687e53d66dea44edb7494494efeac315.png',
		// 	success: function (ret) {
		// 		var path = ret.path;
		// 		var canvas = wx.createCanvasContext('shareCanvas')
		// 		canvas.drawImage(path, 0, 0, 320, 400);
		// 		canvas.draw()
		// 		console.log(path)
		// 		wx.canvasGetImageData({
		// 			canvasId: 'shareCanvas',
		// 			x: 0,
		// 			y: 0,
		// 			width: 320,
		// 			height: 400,
		// 			success(res) {
		// 				let data = that.convertToBMW(res.data);
		// 				console.log("图片二值化后的数据:", data);
		// 				that.data.uiImageEndData.push(data)
		// 			},
		// 			fail: function (error) {
		// 				console.log("error:" + error);
		// 			},
		// 			complete: function () {
		// 				wx.hideLoading()
		// 			}
		// 		})

		// 	},
		// })

	},

	periodicSendSwitchChange: function (e) {
		console.log('switch1 发生 change 事件，携带值为', e.detail.value)
	},

	HexSwitchChange: function (e) {
		console.log('switch2 发生 change 事件，携带值为', e.detail.value)
	}
});